/*
 * Noodle, www.bladox.com
 *
 * Copyright (C) 2004 BLADOX, s.r.o.
 *
 * Help texts and example queries are from http://www.google.com/sms/
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#include <config.h>
#include <turbo/turbo.h>

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* *INDENT-OFF* */

lc_char PROGMEM lc_Noodle[] = {
  LC_EN ("Google SMS") 
  LC_END
};

lc_char PROGMEM lc_Help[] = {
  LC_EN ("Help") 
  LC_END
};

lc_char PROGMEM lc_Query[] = {
  LC_EN ("Query") 
  LC_END
};

lc_char PROGMEM lc_Enter_Query[] = {
  LC_EN ("Enter Query:") 
  LC_END
};

lc_char PROGMEM lc_Local[] = {
  LC_EN ("Google Local") 
  LC_END
};

lc_char PROGMEM lc_Local_Help[] = {
  LC_EN ("Search for the stores and business. Query is composed in two steps: What? e.g. \"pizza\", Where? \"city and state\" or \"zip code\"") 
  LC_END
};

lc_char PROGMEM lc_Enter_What[] = {
  LC_EN ("What:")
  LC_END
};

lc_char PROGMEM lc_Enter_Where[] = {
  LC_EN ("Where:")
  LC_END
};

lc_char PROGMEM lc_PhoneBook[] = {
  LC_EN ("Phone Book") 
  LC_END
};

lc_char PROGMEM lc_PhoneBook_Help[] = {
  LC_EN ("Find publicaly listed phone numbers and addresses in the US. Example queries: \"john smith palo alto ca\", \"650-555-1234\", \"Walsh, 90210\"") 
  LC_END
};

lc_char PROGMEM lc_Prices[] = {
  LC_EN ("Froogle Prices") 
  LC_END
};

lc_char PROGMEM lc_Prices_Help[] = {
  LC_EN ("Froogle lets you search millions of products from stores across the web. Enter a product name, book ISBN (10 digits) or UPC code (12 digits)") 
  LC_END
};

lc_char PROGMEM lc_Enter_Price[] = {
  LC_EN ("Enter Product or ISBN or UPC:") 
  LC_END
};

lc_char PROGMEM lc_Definition[] = {
  LC_EN ("Definition") 
  LC_END
};

lc_char PROGMEM lc_Definition_Help[] = {
  LC_EN ("Find definitions for a word or phrase on the Web, e.g. \"Gordian knot\", \"crepuscular\"") 
  LC_END
};

lc_char PROGMEM lc_Snippet[] = {
  LC_EN ("Snippet") 
  LC_END
};

lc_char PROGMEM lc_Snippet_Help[] = {
  LC_EN ("A snippet is a text excerpt from the returned results page when you do a search on Google, e.g.\"population San Francisco\"") 
  LC_END
};

lc_char PROGMEM lc_Calculator[] = {
  LC_EN ("Calculator")
  LC_END
};

lc_char PROGMEM lc_Calculator_Help[] = {
  LC_EN ("Enter the calculation you'd like done as a query, e.g.\"5+2*2\", \"sqrt(-4)\", \"half a cup in teaspoons\", \"160 pounds * 4000 feet in Calories\"")
  LC_END
};

lc_char PROGMEM lc_Area[] = {
  LC_EN ("Area") 
  LC_END
};

lc_char PROGMEM lc_Area_Help[] = {
  LC_EN ("Send a query with only an area code and see the region that area code covers, e.g. \"617\"") 
  LC_END
};

lc_char PROGMEM lc_Enter_Area[] = {
  LC_EN ("Enter Area Code:") 
  LC_END
};

lc_char PROGMEM lc_ZIP[] = {
  LC_EN ("Zip Look-up") 
  LC_END
};

lc_char PROGMEM lc_ZIP_Help[] = {
  LC_EN ("Send a query with only a zip code and get results for the area that zip code covers, e.g. \"94404\"") 
  LC_END
};

lc_char PROGMEM lc_Enter_ZIP[] = {
  LC_EN ("Enter Zip:") 
  LC_END
};

lc_char PROGMEM lc_About[] = {
  LC_EN ("About") 
  LC_END
};

lc_char PROGMEM lc_About_Text[] = {
  LC_EN ("Noodle 0.9 by BLADOX, www.bladox.com\nGoogle SMS is provided by Google Inc. www.google.com (but everybody knows that...)") 
  LC_END
};

lc_char PROGMEM lc_Send_SMS_OK[] = {
  LC_EN ("SMS send successfully")
  LC_END
};

lc_char PROGMEM lc_Send_SMS_Error[] = {
  LC_EN ("SMS sending error")
  LC_END
};

/* *INDENT-ON* */

u8 help (const lc_char * text)
{
  if (display_text (locale (text), NULL) == APP_END)
    return APP_END;
  return APP_BACK;
}

u8 PROGMEM t_ms_googl[] = "46645";

u8 send_query (u8 * text)	// 0 - failed, 1 - sent ok
{
  u8 *tmp = malloc (161);
  lc_char *s = lc_Send_SMS_Error;
  u8 *r;
  u8 i;
  u8 *ms = str2msisdn (t_ms_googl, MSISDN_ADN, MEM_R);

  if (ms == NULL)
    return perror (ERR_NO_RAM);
  if (tmp == NULL)
  {
    free (ms);
    return perror (ERR_NO_RAM);
  }

  strcpy (tmp, text);

/*
  display_text (tmp, NULL);
  free (ms);
  free (tmp);
  return APP_BACK;
*/

  i = dcs_78 (tmp, strlen (tmp), DCS_8_TO_7);
  r = send_sms (tmp, i, ms, MSISDN_ADN, 0, 0, NULL, NULL);	//7b
  free (tmp);
  free (ms);

  i = get_tag (r, T_RESULT);
  if (i != 0)
  {
    i += 2;
    if (r[i] == 0x00)
      s = lc_Send_SMS_OK;
  }
  return help (s);
}

u8 noodle_local_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_Local_Help);
  return APP_OK;
}

u8 noodle_phonebook_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_PhoneBook_Help);
  return APP_OK;
}

u8 noodle_prices_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_Prices_Help);
  return APP_OK;
}

u8 noodle_definition_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_Definition_Help);
  return APP_OK;
}

u8 noodle_snippet_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_Snippet_Help);
  return APP_OK;
}

u8 noodle_calculator_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_Calculator_Help);
  return APP_OK;
}

u8 noodle_area_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_Area_Help);
  return APP_OK;
}

u8 noodle_zip_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_ZIP_Help);
  return APP_OK;
}

u8 noodle_about (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
    return help (lc_About_Text);
  return APP_OK;
}

u8 noodle_local_query (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 *what = NULL;
    u8 *where = NULL;
    u8 i, j, l;

    res =
      get_input (locale (lc_Enter_What), 1, 100, NULL, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    l = strlen (&res[2]);
    what = malloc (l + 1);
    if (what == NULL)
      return perror (ERR_NO_RAM);
    strcpy (what, &res[2]);

    res =
      get_input (locale (lc_Enter_Where), 1, 60, NULL, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
    {
      free (what);
      return APP_END;
    }
    if (res == NULL)
    {
      free (what);
      return APP_BACK;
    }

    res[res[0] + 1] = '\0';
    i = strlen (&res[2]);

    for (j = i + 1; j > 0; j--)
      res[1 + j + l] = res[1 + j];
    for (i = 0; i < l; i++)
      res[1 + i] = what[i];
    res[1 + i] = '.';
    free (what);

    return send_query (&res[1]);
  }
  return APP_OK;
}

u8 noodle_phonebook_query (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;

    res =
      get_input (locale (lc_Enter_Query), 1, 158, NULL, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    return send_query (&res[2]);
  }
  return APP_OK;
}

u8 noodle_prices_query (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;

    res =
      get_input (locale (lc_Enter_Price), 1, 158, NULL, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;

    res[res[0] + 1] = '\0';
    res[0] = 'F';
    res[1] = ' ';
    return send_query (&res[0]);
  }
  return APP_OK;
}

u8 noodle_definition_query (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;

    res =
      get_input (locale (lc_Enter_Query), 1, 158, NULL, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    res[0] = 'D';
    res[1] = ' ';
    return send_query (&res[0]);
  }
  return APP_OK;
}

u8 noodle_snippet_query (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;

    res =
      get_input (locale (lc_Enter_Query), 1, 158, NULL, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    res[0] = 'G';
    res[1] = ' ';
    return send_query (&res[0]);
  }
  return APP_OK;
}

u8 noodle_calculator_query (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;

    res =
      get_input (locale (lc_Enter_Query), 1, 160, NULL, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    return send_query (&res[2]);
  }
  return APP_OK;
}

u8 noodle_area_query (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;

    res = get_input (locale (lc_Enter_Area), 1, 5, NULL, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    return send_query (&res[2]);
  }
  return APP_OK;
}

u8 noodle_zip_query (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;

    res = get_input (locale (lc_Enter_ZIP), 5, 5, NULL, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[2 + 5] = '\0';
    return send_query (&res[2]);
  }
  return APP_OK;
}

SNodeP noodle_main_n = { lc_Noodle, NULL };

SNodeP noodle_local_n = { lc_Local, NULL };
SNodeP noodle_local_query_n = { lc_Query, noodle_local_query };
SNodeP noodle_local_help_n = { lc_Help, noodle_local_help };

SNodeP noodle_phonebook_n = { lc_PhoneBook, NULL };
SNodeP noodle_phonebook_query_n = { lc_Query, noodle_phonebook_query };
SNodeP noodle_phonebook_help_n = { lc_Help, noodle_phonebook_help };

SNodeP noodle_prices_n = { lc_Prices, NULL };
SNodeP noodle_prices_query_n = { lc_Query, noodle_prices_query };
SNodeP noodle_prices_help_n = { lc_Help, noodle_prices_help };

SNodeP noodle_definition_n = { lc_Definition, NULL };
SNodeP noodle_definition_query_n = { lc_Query, noodle_definition_query };
SNodeP noodle_definition_help_n = { lc_Help, noodle_definition_help };

SNodeP noodle_snippet_n = { lc_Snippet, NULL };
SNodeP noodle_snippet_query_n = { lc_Query, noodle_snippet_query };
SNodeP noodle_snippet_help_n = { lc_Help, noodle_snippet_help };

SNodeP noodle_calculator_n = { lc_Calculator, NULL };
SNodeP noodle_calculator_query_n = { lc_Query, noodle_calculator_query };
SNodeP noodle_calculator_help_n = { lc_Help, noodle_calculator_help };

SNodeP noodle_area_n = { lc_Area, NULL };
SNodeP noodle_area_query_n = { lc_Query, noodle_area_query };
SNodeP noodle_area_help_n = { lc_Help, noodle_area_help };

SNodeP noodle_zip_n = { lc_ZIP, NULL };
SNodeP noodle_zip_query_n = { lc_Query, noodle_zip_query };
SNodeP noodle_zip_help_n = { lc_Help, noodle_zip_help };

SNodeP noodle_about_n = { lc_About, noodle_about };

/* *INDENT-OFF* */
SEdgeP noodle_edges[] = {
  {&noodle_main_n, &noodle_local_n},
  {&noodle_main_n, &noodle_phonebook_n},
  {&noodle_main_n, &noodle_prices_n},
  {&noodle_main_n, &noodle_definition_n},
  {&noodle_main_n, &noodle_snippet_n},
  {&noodle_main_n, &noodle_calculator_n},
  {&noodle_main_n, &noodle_area_n},
  {&noodle_main_n, &noodle_zip_n},
  {&noodle_main_n, &noodle_about_n},
  {&noodle_local_n, &noodle_local_query_n},
  {&noodle_local_n, &noodle_local_help_n},
  {&noodle_phonebook_n, &noodle_phonebook_query_n},
  {&noodle_phonebook_n, &noodle_phonebook_help_n},
  {&noodle_prices_n, &noodle_prices_query_n},
  {&noodle_prices_n, &noodle_prices_help_n},
  {&noodle_definition_n, &noodle_definition_query_n},
  {&noodle_definition_n, &noodle_definition_help_n},
  {&noodle_snippet_n, &noodle_snippet_query_n},
  {&noodle_snippet_n, &noodle_snippet_help_n},
  {&noodle_calculator_n, &noodle_calculator_query_n},
  {&noodle_calculator_n, &noodle_calculator_help_n},
  {&noodle_area_n, &noodle_area_query_n},
  {&noodle_area_n, &noodle_area_help_n},
  {&noodle_zip_n, &noodle_zip_query_n},
  {&noodle_zip_n, &noodle_zip_help_n},
  NULL
};
/* *INDENT-ON* */

void action_menu (Menu_selection_data * x)
{
  SCtx *c = spider_init ();

  c->eP = &noodle_edges;
  c->n = &noodle_main_n;
  spider (c);
}

void turbo_handler (u8 action, void *data)
{
  switch (action)
  {
    case ACTION_INSERT_MENU:
      insert_menu (locale (lc_Noodle));
      break;

    case ACTION_MENU_SELECTION:
      stk_thread (action_menu, data);
      break;

    default:
      break;
  }
}
